Added --compressed flag to zfs send cmds
[zfs-ubuntu/.git] / zfs-replicate
index 174d6dd5ef7f834e0efa252a5e5545e7e47c08dd..b3f7cffd16d31dc3bbfa44df3ce5b7cdd2840b5f 100755 (executable)
@@ -17,7 +17,6 @@ config="${0%/*}/zfs-scripts.conf"
 remote=$1
 remote_fs=$2
 remote_pool=${2%%/*}
-hostname=`hostname`
 
 # Setup our cleanup and exit trap
 cleanup() {
@@ -34,17 +33,17 @@ cleanup() {
 }
 fatal_and_exit() {
   echo -e 2>&1 "$1"
-  # Destroy the backup markers on the local filesystem if they exist
+  # Destroy the current backup markers from the local backup_pool and remote_pool if they exist
   if [[ -n "$current_backup_marker" ]]; then
-    zfs list -t snapshot ${backup_pool}/${current_backup_marker} > /dev/null 2>&1
+    # Local backup pool current backup marker
+    $zfs list -t snapshot ${backup_pool}/${current_backup_marker} > /dev/null 2>&1
     if [ $? == 0 ]; then
       $zfs destroy ${backup_pool}/${current_backup_marker}
     fi
-  fi
-  if [[ -n "$previous_backup_marker" ]]; then
-    zfs list -t snapshot ${backup_pool}/${previous_backup_marker} > /dev/null 2>&1 
+    # Remote pool current backup marker
+    $ssh $remote zfs list -t snapshot ${current_backup_marker} > /dev/null 2>&1
     if [ $? == 0 ]; then
-      $zfs destroy ${backup_pool}/${previous_backup_marker}
+      $ssh $remote $zfs destroy ${current_backup_marker}
     fi
   fi
   # send email notification
@@ -57,6 +56,27 @@ fatal_and_exit() {
 trap fatal_and_exit INT
 trap cleanup EXIT
 
+# Declare a function to handle the replicate operation
+replicate() {
+  zfs_send="$1"
+  zfs_recv="$zfs receive -vF -d ${backup_pool}/${remote_pool}"
+  glue="$throttle $throttle_opt"
+  if [[ $throttle_enable == 1 && -e $throttle ]]; then
+    # handle using the glue in the local and remote host case properly
+    if [[ -z "$ssh" ]]; then
+      # local host glue case
+      $zfs_send | $glue | $zfs_recv 
+    else
+      # remote host glue case
+      $ssh $remote "$zfs_send | $glue" | $zfs_recv
+    fi
+  else 
+    # no glue case - works for both the local and remote host cases
+    $ssh $remote $zfs_send | $zfs_recv
+  fi
+  # The return code of the zfs_send | zfs_recv operation will be returned to the caller
+}
+
 # Make sure we have valid arguments
 if [[ -z "$remote" ]] || [[ -z "$remote_fs" ]]; then
   fatal_and_exit "Usage: $0 <hostname> <zfs filesystem>"
@@ -71,7 +91,7 @@ fi
 # Make sure the local backup pool and local receiving filesystem exist, or print some errors
 zpool list -H "$backup_pool" >/dev/null 2>&1
 if [ $? != 0 ]; then
-  fatal_and_exit "-E- The local backup pool, '$backup_pool' doesn't seem to exist." $mailto
+  fatal_and_exit "-E- The local backup pool on $hostname, '$backup_pool' doesn't seem to exist." $mailto
 fi
 zfs list "$backup_pool/$remote_pool" >/dev/null 2>&1
 if [ $? != 0 ]; then
@@ -79,7 +99,7 @@ if [ $? != 0 ]; then
   echo >&2 "    Creating the local filesystem to receive the remote pool into: $backup_pool/$remote_pool"
   $zfs create $backup_pool/$remote_pool
   if [ $? != 0 ]; then
-    fatal_and_exit "-E- remote $zfs create command failed" $mailto
+    fatal_and_exit "-E- remote $zfs on $hostname create command failed" $mailto
   fi
 fi
 
@@ -87,7 +107,7 @@ fi
 backup_pool_guid=`zpool get guid $backup_pool 2>&1 | grep $backup_pool | awk '{ print $3 }'`
 zpool get guid $backup_pool > /dev/null 2>&1
 if [ $? != 0 ]; then
-  fatal_and_exit "-E- Unable to extract the guid for the local backup pool: $backup_pool" $mailto
+  fatal_and_exit "-E- Unable to extract the guid for the local backup pool on $hostname: $backup_pool" $mailto
 fi
 
 # Turn on shell verbosity
@@ -114,7 +134,7 @@ while true; do
     # We've exceeded our maximum while loop count
     echo "-E- The zfs filesystem has been locked down. Skipping replicate operation."
     fail_msg=`$ssh $remote ls -ld $lockdir 2>&1`
-    fatal_and_exit "zfs-replicate-all unable to obtain zfs admin lock:\n$fail_msg" $mailto
+    fatal_and_exit "zfs-replicate-all on $hostname unable to obtain zfs admin lock:\n$fail_msg" $mailto
   fi
 done
 
@@ -129,7 +149,7 @@ $ssh $remote \
     grep ^${remote_fs}@ |
     awk '{print$1}' > $remote_list
 if [ $? != 0 ]; then
-  fatal_and_exit "-E- remote $zfs list command failed" $mailto
+  fatal_and_exit "-E- remote $zfs list on $hostname command failed" $mailto
 fi
 
 # List the snapshots on the local machine.
@@ -141,7 +161,7 @@ $zfs list -H -t snapshot |
     grep -v ^${backup_pool}/${current_backup_marker} | 
     awk "{gsub(/^$backup_pool./,\"\",\$1); print\$1}" > $local_list
 if [ $? != 0 ]; then
-  fatal_and_exit "-E- local $zfs list command failed" $mailto
+  fatal_and_exit "-E- local $zfs list on $hostname command failed" $mailto
 fi
 
 # Destroy the current backup marker snapshot on the remote system if it exists
@@ -149,14 +169,14 @@ grep -q ${current_backup_marker} $remote_list
 if [ $? == 0 ]; then
   $ssh $remote $zfs destroy ${current_backup_marker} 
   if [ $? != 0 ]; then
-    fatal_and_exit "-E- remote $zfs destroy command failed" $mailto
+    fatal_and_exit "-E- remote $zfs destroy on $hostname command failed" $mailto
   fi
 fi
 
 # Create the current backup marker snapshot on the remote system
 $ssh $remote $zfs snapshot ${current_backup_marker}
 if [ $? != 0 ]; then
-  fatal_and_exit "-E- remote $zfs snapshot command failed" $mailto
+  fatal_and_exit "-E- remote $zfs snapshot on $hostname command failed" $mailto
 fi
 
 # Check to see if the previous backup marker exists in the remote snapshot list.
@@ -178,18 +198,12 @@ if [ $no_markers == 0 ]; then
   # previous backup marker again from a previously interrupted replicate.
   $zfs rollback -r ${backup_pool}/${previous_backup_marker} 
   if [ $? != 0 ]; then
-    fatal_and_exit "-E- remote incremental $zfs rollback command failed" $mailto
+    fatal_and_exit "-E- remote incremental $zfs rollback command failed on $hostname" $mailto
   fi
   # Now it should be safe to send the snaps
-  if [[ $throttle_enable == 1 && -e $throttle ]]; then
-    $ssh $remote $zfs send -R -I${previous_backup_marker} ${current_backup_marker} | 
-        $throttle $throttle_opt | $zfs receive -vF -d ${backup_pool}/${remote_pool}
-  else 
-    $ssh $remote $zfs send -R -I${previous_backup_marker} ${current_backup_marker} |
-        $zfs receive -vF -d ${backup_pool}/${remote_pool}
-  fi
+  replicate "$zfs send -Rc -I${previous_backup_marker} ${current_backup_marker}"
   if [ $? != 0 ]; then
-    fatal_and_exit "-E- remote incremental $zfs send command failed" $mailto
+    fatal_and_exit "-E- remote incremental $zfs send command failed on $hostname" $mailto
   fi
 else
   # We didn't find any backup markers, next check to see if we have a common snapshot.
@@ -206,15 +220,9 @@ else
 
   if [[ -n "$common" ]]; then
     # We found a common snapshot, incrementally send the new snaps
-    if [[ $throttle_enable == 1 && -e $throttle ]]; then
-      $ssh $remote $zfs send -R -I${common/*@/@} ${current_backup_marker} |
-          $throttle $throttle_opt | $zfs receive -vF -d ${backup_pool}/${remote_pool}
-    else
-      $ssh $remote $zfs send -R -I${common/*@/@} ${current_backup_marker} |
-          $zfs receive -vF -d ${backup_pool}/${remote_pool}
-    fi
+    replicate "$zfs send -Rc -I${common/*@/@} ${current_backup_marker}"
     if [ $? != 0 ]; then
-      fatal_and_exit "-E- remote incremental $zfs send command failed" $mailto
+      fatal_and_exit "-E- remote incremental $zfs send command failed on $hostname" $mailto
     fi
   else
     # We did not find any markers or a common snapshot
@@ -225,24 +233,18 @@ else
       if [[ $destroy_local_filesystem_on_full_replicate == 1 ]]; then
         $zfs destroy -r ${backup_pool}/${remote_fs}
         if [ $? != 0 ]; then
-          fatal_and_exit "-E- remote full $zfs destroy command failed" $mailto
+          fatal_and_exit "-E- remote full $zfs destroy command failed on $hostname" $mailto
         fi
       else
         echo "-W- We need to destroy a local filesystem before receiving a full stream."
        echo "    However, since the option is set to prevent this, skipping replicate operation."
-        fatal_and_exit "unable to destroy local filesystem:\n$zfs destroy -r ${backup_pool}/${remote_fs} not able to run" $mailto
+        fatal_and_exit "unable to destroy local filesystem:\n$zfs destroy -r ${backup_pool}/${remote_fs} not able to run on $hostname" $mailto
       fi
     fi
     # Send the full filesystem
-    if [[ $throttle_enable == 1 && -e $throttle ]]; then
-      $ssh $remote $zfs send -R ${current_backup_marker} |
-          $throttle $throttle_opt | $zfs receive -vF -d ${backup_pool}/${remote_pool}
-    else
-      $ssh $remote $zfs send -R ${current_backup_marker} |
-          $zfs receive -vF -d ${backup_pool}/${remote_pool}
-    fi
+    replicate "$zfs send -Rc ${current_backup_marker}"
     if [ $? != 0 ]; then
-      fatal_and_exit "-E- remote full $zfs send command failed" $mailto
+      fatal_and_exit "-E- remote full $zfs send command failed on $hostname" $mailto
     fi
   fi
 fi
@@ -255,9 +257,9 @@ $ssh $remote $zfs destroy ${previous_backup_marker} > /dev/null 2>&1
 # Rename the current backup marker to be the previous backup marker
 $zfs rename ${backup_pool}/${current_backup_marker} ${backup_pool}/${previous_backup_marker}
 if [ $? != 0 ]; then
-  fatal_and_exit "-E- local $zfs rename command failed" $mailto
+  fatal_and_exit "-E- local $zfs rename command failed on $hostname" $mailto
 fi
 $ssh $remote $zfs rename ${current_backup_marker} ${previous_backup_marker}
 if [ $? != 0 ]; then
-  fatal_and_exit "-E- remote $zfs rename command failed" $mailto
+  fatal_and_exit "-E- remote $zfs rename command failed on $hostname" $mailto
 fi